"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var UNMISTAKABLE_CHARS = '23456789ABCDEFGHJKLMNPQRSTWXYZabcdefghijkmnopqrstuvwxyz';
var BASE64_CHARS = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ' + '0123456789-_';
var AbstractRandomGenerator = (function () {
    function AbstractRandomGenerator() {
    }
    AbstractRandomGenerator.prototype.hexString = function (digits) {
        return this.randomString(digits, '0123456789abcdef');
    };
    AbstractRandomGenerator.prototype.randomString = function (charsCount, alphabet) {
        var result = '';
        for (var i = 0; i < charsCount; i++) {
            result += this.choice(alphabet);
        }
        return result;
    };
    AbstractRandomGenerator.prototype.id = function (charsCount) {
        if (charsCount === void 0) { charsCount = 17; }
        return this.randomString(charsCount, UNMISTAKABLE_CHARS);
    };
    AbstractRandomGenerator.prototype.secret = function (charsCount) {
        if (charsCount === void 0) { charsCount = 43; }
        return this.randomString(charsCount, BASE64_CHARS);
    };
    AbstractRandomGenerator.prototype.choice = function (arrayOrString) {
        var index = Math.floor(this.fraction() * arrayOrString.length);
        if (typeof arrayOrString === 'string') {
            return arrayOrString.substr(index, 1);
        }
        return arrayOrString[index];
    };
    return AbstractRandomGenerator;
}());
exports.default = AbstractRandomGenerator;
