"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAleaGenerator = void 0;
var AbstractRandomGenerator_1 = __importDefault(require("./AbstractRandomGenerator"));
function Alea(seedArray) {
    function MashFactory() {
        var n = 0xefc8249d;
        var mash = function (data) {
            data = data.toString();
            for (var i = 0; i < data.length; i++) {
                n += data.charCodeAt(i);
                var h = 0.02519603282416938 * n;
                n = h >>> 0;
                h -= n;
                h *= n;
                n = h >>> 0;
                h -= n;
                n += h * 0x100000000;
            }
            return (n >>> 0) * 2.3283064365386963e-10;
        };
        mash.version = 'Mash 0.9';
        return mash;
    }
    return (function (args) {
        var s0 = 0;
        var s1 = 0;
        var s2 = 0;
        var c = 1;
        if (args.length == 0) {
            args = [Date.now().toString()];
        }
        var mash = MashFactory();
        s0 = mash(' ');
        s1 = mash(' ');
        s2 = mash(' ');
        for (var i = 0; i < args.length; i++) {
            s0 -= mash(args[i]);
            if (s0 < 0) {
                s0 += 1;
            }
            s1 -= mash(args[i]);
            if (s1 < 0) {
                s1 += 1;
            }
            s2 -= mash(args[i]);
            if (s2 < 0) {
                s2 += 1;
            }
        }
        mash = null;
        var random = function () {
            var t = 2091639 * s0 + c * 2.3283064365386963e-10;
            s0 = s1;
            s1 = s2;
            return (s2 = t - (c = t | 0));
        };
        random.uint32 = function () {
            return random() * 0x100000000;
        };
        random.fract53 = function () {
            return (random() + ((random() * 0x200000) | 0) * 1.1102230246251565e-16);
        };
        random.version = 'Alea 0.9';
        random.args = args;
        return random;
    })(seedArray);
}
var AleaRandomGenerator = (function (_super) {
    __extends(AleaRandomGenerator, _super);
    function AleaRandomGenerator(_a) {
        var _b = (_a === void 0 ? {} : _a).seeds, seeds = _b === void 0 ? [] : _b;
        var _this = _super.call(this) || this;
        if (!seeds) {
            throw new Error('No seeds were provided for Alea PRNG');
        }
        _this.alea = Alea(seeds);
        return _this;
    }
    AleaRandomGenerator.prototype.fraction = function () {
        return this.alea();
    };
    return AleaRandomGenerator;
}(AbstractRandomGenerator_1.default));
exports.default = AleaRandomGenerator;
var height = (typeof window !== 'undefined' && window.innerHeight) ||
    (typeof document !== 'undefined' &&
        document.documentElement &&
        document.documentElement.clientHeight) ||
    (typeof document !== 'undefined' &&
        document.body &&
        document.body.clientHeight) ||
    1;
var width = (typeof window !== 'undefined' && window.innerWidth) ||
    (typeof document !== 'undefined' &&
        document.documentElement &&
        document.documentElement.clientWidth) ||
    (typeof document !== 'undefined' &&
        document.body &&
        document.body.clientWidth) ||
    1;
var agent = (typeof navigator !== 'undefined' && navigator.userAgent) || '';
function createAleaGenerator() {
    return new AleaRandomGenerator({
        seeds: [new Date(), height, width, agent, Math.random()],
    });
}
exports.createAleaGenerator = createAleaGenerator;
