"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
var nodeCrypto = __importStar(require("crypto"));
var BrowserRandomGenerator_1 = __importDefault(require("./BrowserRandomGenerator"));
var AleaRandomGenerator_1 = __importStar(require("./AleaRandomGenerator"));
var NodeRandomGenerator_1 = __importDefault(require("./NodeRandomGenerator"));
function createRandom(generator) {
    generator.createWithSeeds = function () {
        var seeds = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            seeds[_i] = arguments[_i];
        }
        if (seeds.length === 0) {
            throw new Error('No seeds were provided');
        }
        return new AleaRandomGenerator_1.default({ seeds: seeds });
    };
    generator.insecure = AleaRandomGenerator_1.createAleaGenerator();
    return generator;
}
var generator;
if (nodeCrypto) {
    generator = new NodeRandomGenerator_1.default();
}
else if (((_a = window === null || window === void 0 ? void 0 : window.crypto) === null || _a === void 0 ? void 0 : _a.getRandomValues) !== undefined) {
    generator = new BrowserRandomGenerator_1.default();
}
else {
    generator = AleaRandomGenerator_1.createAleaGenerator();
}
var Random = createRandom(generator);
module.exports = Random;
